<?php
function parse_email ($email) 
{
	// Split header and message
	$header = array();
	$message = array();

    $is_header = true;
    foreach ($email as $line) 
    {
        if ($line == '<HEADER> ' . "\r\n") continue;
        if ($line == '<MESSAGE> ' . "\r\n") continue;
        if ($line == '</MESSAGE> ' . "\r\n") continue;
        if ($line == '</HEADER> ' . "\r\n") { $is_header = false; continue; }

        if ($is_header == true) 
        {
            $header[] = $line;
        } else {
            $message[] = $line;
        }
    }

    // Parse headers
    $headers = array();
    foreach ($header as $line) 
    {
        $colon_pos = strpos($line, ':');
        $space_pos = strpos($line, ' ');

        if ($colon_pos === false OR $space_pos < $colon_pos) 
        {
            // attach to previous
            $previous .= "\r\n" . $line;
            continue;
        }

        // Get key
        $key = substr($line, 0, $colon_pos);

        // Get value
        $value = substr($line, $colon_pos+2);
        $headers[$key] = $value;

        $previous =& $headers[$key];
    }

    // Parse message
    $message = implode('', $message);

    // Return array
    $email = array();
    $email['message'] = $message;
    $email['headers'] = $headers;

    return $email;
} 

function split_bounds ($data, $bound)
{
	while (preg_match("#([-]+|)$bound(.+?)([-]+)$bound#is", $data, $strip))
	{
		$strips[] = $strip[2];
		$data = str_replace($strip[0], $bound, $data);
	}
	
	return $strips;
}

// strip out the sub-headers!
function strip_headers ($data, $rev = 0)
{
	//echo $data;
	$data = explode("\n", $data);
	while (list($num, $line) = each($data))
	{
		$x++;
		
		if( $rev == 1 ) 
		{
			$collect .= $line . "\n";
		}
		
		$line = trim($line);
		if( $line == "" AND $x != 1 ) 
		{
			break;
		}
		elseif( $rev != 1 ) 
		{
			unset($data[$num]);
		}
	}

	if( $rev == 1 )
	{
		$data = $collect;
	}
	else
	{
		$data = implode("\n", $data);
	}

	return $data;
}

function handle_split($data, $bound,$plain_only)
{

	// split using boundaries!
	$strips = split_bounds($data, $bound);
	foreach ($strips as $content)
	{
		if (preg_match('#boundary="(.+)"#i', $content, $boundary))
		{
			if (stristr($content, 'multipart/alternative;')) 
			{
				$plain_only = 1;
			}
			
			$boundary = $boundary[1];
			handle_split( $content, $boundary );
			continue;
		}
	
		if (stristr($content, 'quoted-printable')) 
		{
			$content = quoted_printable_decode($content);
		}

		if (preg_match('#Content-Type(.+?)text/(plain|html)#i', $content, $type))
		{
			if ($plain_only == 1 AND $type[2] == 'html') 
			{
				continue;
			}
			
			$headers  = strip_headers($content, 1);
			$body = strip_headers($content);
			
			if (stristr($headers, 'Content-transfer-encoding: base64')) 
			{
				$body = base64_decode($body);
			}			
		}
	}
	
	return $body;
}
?>